###############
sub my_action {
###############
    # may 2024, win

#override with private functions?
##################################
eval { &mylib_menue_folder_create };                   # create this function in a private mylib.pl to replace this action
my ($var1,$ant,$utf,$z,$r,$f,$k,$ks,$mess,$t1,$t1,@m,$hash);

&load_lib("keyserverlib.pl");  # common subs

# no spaces or special char in fs name
$in{'value_new'}=~s/[^a-zA-Z0-9\-\_\.]/_/g;

# get default enc values
$ks.=",on:3x keysplit (Local or W1 or W2)";                          #   only enc option


# header
  print "<script language='javascript'>document.getElementById('hl').innerHTML='Create ZFS filesystem on $in{'member'}\:$current{'on'}'</script>\n";


# 1. edited=
  if ($in{'submit_ok'} ne "submit")     { $in{'answered'} =""; }  #not klicked on submit but on autoselect (encrypt)
  if ($in{'answered'}) {

       &my_create;
  }     # form -> create

# 1b. get subfolders below current pool
  $ant=&exe("zfs list -H -t filesystem -o name");
  @t=();
  @t=split(/\n/,$ant);
  foreach $t (@t) {
     #if ($t=~/^$zfs{'syspool'}/) { next; }
     $z.="$t,";
  }

  $z=~s/,$//;
  if ($z eq "") { $z=$zfs{'datapools'}; }

# 2. get form
#########################
if ($in{'autoselect_pool'} eq "") {   $in{'autoselect_pool'}=$zfs{'datapools'}; $in{'autoselect_pool'} =~s/\t.*//; }

print "<br><b style='font-size:16px'>Filesystem pool and name</b><br>";

&ask('begin');
&ask('autoselect_pool','Pool or parent filesystem',$z,$in{'autoselect_pool'});
&ask('value_new',"New Filesystem",$in{'value_new'});
&ask('value_hash',"Enc pw for sha256hex hash (max 32char, optional)<br>Use a short, easy to remember pw, then enable enc to create a hash as passphrase1",$in{'value_hash'});
&ask('value_info',"Info or pw hint<br>as a private ZFS property info:",$in{'value_info'});

print "<br><br><b style='font-size:16px'>Encryption settings</b><br><br>";


## encrypt
$t=&exe("zfs get all $in{'autoselect_pool'}");
chomp($t);

#ex: tank  encryption            off

if (!($t=~/encryption/s)) {
    &ask('select_crypt','ZFS Encryption (BSD, Illumos, Linux, OSX or Windows) ',"not available");

} else {
     if ($in{'value_hash'} ne "") {
        $t="$in{'autoselect_pool'}$in{'value_new'}$in{'value_hash'}";  $t=~s/~|\///g;
        $hash= sha256_hex("$t");          # sha of filedystem+pw
     }

     #selected pool = first or selected
     if ($in{'autoselect_pool'} eq "") {
          $t=$zfs{'datapools'}; $t=~s/\t.*//;        # first pool
     } else {
          $t=$in{'autoselect_pool'};
     }

     $t.="_encryption";

     #pool encr=on
     if ($zfs{$t} eq "on") {
             print "<b>Encryption</b> was set to on for all folders of this pool<br><br><br>";
     }

     ### martingo 20180306 >>> Wenn autoselect_pool ein verschluesseltes ZFS ist, kann es den keystatus unavailable (nicht entschluesselt)
     ### oder available (verschluesselt) haben.
     ### Wenn es nicht verschluesselt ist, ist der keystatus none
     ### Wenn das Parent ZFS bereits verschluesselt ist, gibt es im DropDown nur noch die Moeglichkeit auto.

      if ( $zfs{ $in{'autoselect_pool'} . '_keystatus' } =~ /^(un)?available$/ ) {
             &ask('autoselect_crypt','Encryption inherited from parent','auto');

      } else {

            #  ask always
            print "select pool, enter name and optional a pw prior enabling encryption";
            &ask('autoselect_crypt',"ZFS filesystem encryption with keysource file</b><br>$mess<b>","off$ks",$in{'autoselect_crypt'});

            if ($in{'autoselect_crypt'} =~/on/) {
                 #if ($cfg{'value_keydata_fs'} eq "")    { &mess("Set keylocation in About > Settings"); }      # use _log/keys always
                 if (!(-d "$wpath/_log/keys"))          { &mess("Keylocation /web-gui/_log/keys not found"); }

                 &ask('select_str','Strenght',"aes-256-gcm,aes-256-ccm,aes-128-ccm,aes-192-ccm,aes-128-gcm,aes-192-gcm",$in{'select_str'});
                 print "<br><b class='font_darkred'> Without this passphrase, you will never be able to reaccess your data, Backup passphrase or files fsid.kp1,fsid.kp2 and fsid.kp3<br> in folder $cfg{'value_keydata_fs'} and keep them at a safe place! Try a lock + unlock prior use! </b><br><br>";

                 #sha256hex hash key from filesystem + pw

                 &ask('value_crypt1',"Passphrase 8-512 char or SHA 256 hex hash from pw + filesystem</b><br>to unlock manually with a shorter and easy to remember pw: <b>$in{'value_hash'}","$hash",'w420');
                 &ask('value_crypt2','Repeat Passphrase (copy/paste/backup)</b><br>try lock and unlock filesystem prior use<b>','','w420');

                 #random suggestion

                 $t=&get_random_ascii(64);
                 &ask('value_x','Random 64 Byte Passphrase suggestion </b><br>(copy/paste to use)<b>',$t,'w420readonly');

                 #keyfile
                 my $keyfile="$tpath/$in{'member'}\~$in{'autoselect_pool'}\~$in{'value_new'}.key";
                 &ask('value_y','Keyfile (ZFS property to create or unlock) file://</b><br>You can backup/delete/split (L/W1/W2) after creation<b>',$keyfile,'w420readonly');

                 # autounlock?
                 &ask('select_autounlock','Autounlock on bootup</b><br>(private property autounlock:)<b>',"yes,no");

            }
      }
}

#debug
#&print_hash(%cfg);

print "<br><br>";
print "<b style='font-size:16px'>Other settings</b><br><br>";

print " <i>$txt{'form_atime_i'}</i><br>";
&ask('select_atime',"Atime (access time)",'off,on');
&ask('select_copies',"Copies=2 writes any datablock twice as an option for <br>single disk pools like USB sticks or disks to autorepair files with bad datablocks",'1,2');

#obsolet netatalk 3 ?
print " <i>$txt{'form_nbmand_i'}</i><br>";
&ask('select_nbmand','nbmand (filelocking, should be on)','on,off');


#recordsize
  print "read about recordsize: blogs from <a href='http://www.joyent.com/blog/bruning-questions-zfs-record-size' target='_blank'>Joyent</a> and <a href='https://blogs.oracle.com/roch/entry/tuning_zfs_recordsize' target='_blank'>Oracle</a>";
  &ask('select_recordsize',"ZFS recordsize (default=128k","default,1m,128k,64k,32k,16k,8k,4k",$in{'select_version'});

 #compress
  print "ZFS lz4 compress is very effective. You can enable it in most cases per default with any type of data";
  &ask('select_compress',"ZFS compress (lz4)","on,off",$in{'select_compress'});

# create only
print "settings that cannot be changed after creation<br><br>";

#utf8only
print " <i>utf8only and normalization</i><br>";
&ask('select_utf','set to off for cases like <br>rsync to NFS3 with special chars','on formD,off');

print "<i>$txt{'form_sens_info'}</i><br>";
&ask('select_sensitivity','case sensitivity','insensitive,sensitive,mixed');

&ask('end');

print "<br><br><div class='info'>\ncreate a new ZFS-folder/ dataset (with the following defaults):<br><br>keep in mind: SMB and AFP use ACL, some like ftp use unix permissions. <br>create-defaults are: root=full, everybody=modify, nbmand=off and utf8 charset to prevent illegal characters in filenames <br>";
print "default unix permissions are set to 777 = full access for everybody, needed for ACL settings and smb-guest access. Restrict them only if needed and use ACL for your shares</div><br><br>";



print "<br><br>ZFS:<br>";
$r=&exe("zfs list -t filesystem");
$r=~s/  +/\t/gs;

if ($cfg{'select_lang'}=~/my|app/i) {
   $r=~s/napp\-it/*appl*/gs;
}

print &list2table($r);
print "<br>";
#########################

# header
print "<script language='javascript'>document.getElementById('hl').innerHTML='create ZFS filesystem on $in{'member'}\:$current{'on'}'</script>\n";


} #/ my_action
################

################         # create encrypted on Solaris
sub my_create_enc {
################

#&print_hash(%in);
        # enc on Solaris:     -o keysource=passphrase,file:///filename
        # zfs create -o encryption=aes-256-ccm -o keysource=raw,file:///path/key.file  tank/enc

        # enc on Open-zfs:    -o keyformat=passphrase -o keylocation=file://abspath
        # zfs create -o encryption=aes-256-gcm -o keyformat=passphrase -o keylocation=file:///path/key.file tank/enc

        if (length($in{'value_crypt1'}) <= 32) {  &mess('Use more than 32 char for a key to allow a safe keysplit'); }

        my ($do,$key,$f,$fo,$id,$par,@id,$f1,$f2,$ft,$k1,$k2,$k3,$guest,$r);

        my $fn=$in{'autoselect_pool'};
        $fn=~s/\//~/g;   # tank/data -> tank~data

        #keyfile
        my $keyfile="$wpath/_log/keys/$in{'member'}\~$fn\~$in{'value_new'}.completekey";

        # tmp key to create a fs, delete then
        # save key by server.pl to ./cs_server/tmp


        my $keyname="$in{'member'}\~$fn\~$in{'value_new'}.completekey";

        # write keyfile and kp1-kp3 to ./_lib/keys
        $r=&save_key_local();      # keyserverlib

        # check
        if (!(-f $keyfile)) { &mess("keyfile missing <hr>$keyfile"); }

        #utf8 only and normalization=on or none (default)
         $utf=" -o utf8only=on -o normalization=formD";
         if ($in{'select_utf'} eq "off") { $utf=""; }

        # add recordsize
        if ($in{'select_recordsize'}=~/\d/) {
          $utf.=" -o recordsize=$in{'select_recordsize'}";
        }

        # add compress
        if ($in{'select_compress'}=~/on/) {
          $utf.=" -o compress=lz4";
        }

        $id="$in{'autoselect_pool'}/$in{'value_new'}";
        $id=~s/ /_/g; $id=~s/\//~/g;

        # fs keysource (sol) or keylocation (Ill) always file

        # you need the keyfile in cs_server/tmp
        # upload to https and download to tmp
        # $w="rcmd:writefile::filename::data::EndOfFile::";
        $r=&exe("rcmd::writefile::$keyname\::$in{'value_crypt1'}\::EndOfFile::");              # via upload https, returns filename and path
        if (!($r=~/\.completekey$/)) { &mess("key upload error:<hr>$r"); }


        if ($sys{'on'}=~/Solaris 11/i)  {

             $key=" -o keysource=passphrase,file:///$r";                                       # keysource=passphrase,file

        } else {

             #OpenZFS
             $key=" -o keyformat=passphrase -o keylocation=file:///$r";

        }
        $key=~s/\/\/\/+/\/\/\//;    #avoid problems with paths due d:/xx (win) or //tank/data ot tank/data

        $in{'value_new'}=~s/\/+$//;

        # &mess("$tmpkey uploaded and in place<hr>$key");


        # create enc
        $do="zfs create$utf -o encryption=$in{'select_str'}$key -o snapdir=hidden -o casesensitivity=$in{'select_sensitivity'} -o nbmand=$in{'select_nbmand'} -o sharesmb=off -o atime=$in{'select_atime'} $in{'autoselect_pool'}/$in{'value_new'}";
        $r=&exe($do);
        print "$do<hr>";
        if ($r ne "") { print "$r"; }

        #autounlock: property
        if ($in{'select_autounlock'} eq "yes") {
            print &exe("zfs set autounlock:=yes $in{'autoselect_pool'}/$in{'value_new'}");
        }

        # del all tmp complete keys  rcmd::del_tmp_keys
        sleep(3);
        print "<br>";
       # print &exe("rcmd::del_tmp_keys::");
        return;

}


################
sub my_create {
################
  my ($do,$guest,$version,$utf,$exp,$f,$key,$file,$r,$t1,$t2);

#&print_hash(%in);
  # zfs create -o casesensitivity=insensitive -o nbmand=on fsname

   #strict
   $in{'value_new'}=~s/[^a-zA-Z0-9_\/\.\-:]//g;            # allowed in name
   $in{'value_new'}=~s/^\/+//g;                            # not allowed in name

   if ($in{'value_new'} eq '') { &mess('name of dataset?'); }

   my $zfs="$in{'autoselect_pool'}/$in{'value_new'}";

   #exist??
   $t=&exe("zfs list -H -o name $zfs");
   chomp($t);
   if ($t eq "$zfs")  { &mess("filesystem $zfs already exists!"); }

   #crypt
   if ($in{'autoselect_crypt'} =~/on/) {
     if ($in{'value_crypt1'} eq "") {                         &mess('You must enter and confirm a passphrase to enable encrypt!'); }
     if (length($in{'value_crypt1'}) < 8) {                   &mess('Your passphrase must have at least 8 char'); }
     if (length($in{'value_crypt1'}) >512) {                  &mess('Your passphrase must not have more than 512 char'); }
     if ($in{'value_crypt1'} ne $in{'value_crypt2'}) {        &mess('your Passphrases are different'); }
   }


  #&print_hash(%in);


   #################################
   #create fs
   ############
   #parse perm


   # with encryption
   if ($in{'autoselect_crypt'}=~/on/) {

         &my_create_enc;

   } else {                     #without encryption or auto (inherit)
         #
         #utf8 only and normalization=on or none (default)
         $utf=" -o utf8only=on -o normalization=formD";
         if ($in{'select_utf'} eq "off") { $utf=""; }

         #  add recordsize
         if ($in{'select_recordsize'}=~/\d/) {
            $utf.=" -o recordsize=$in{'select_recordsize'}";
         }

         # add copies
         if ($in{'select_copies'} eq "2") {
             $utf.=" -o copies=2";
         }

         # add compress
         if ($in{'select_compress'}=~/on/) {
             $utf.=" -o compress=lz4";
         }


         #snapdir hidden, access via windows previous version
         # option compress=inherit or off

         $in{'value_new'}=~s/ /_/g;    # no spaces

         # $do="zfs create$version$utf -o snapdir=hidden -o casesensitivity=$in{'select_sensitivity'} -o nbmand=$in{'select_nbmand'} -o sharesmb=off -o atime=$in{'select_atime'} -o compression=off \"$in{'autoselect_pool'}/$in{'value_new'}\"";
         $do="zfs create$utf -o snapdir=hidden -o casesensitivity=$in{'select_sensitivity'} -o nbmand=$in{'select_nbmand'} -o sharesmb=off -o atime=$in{'select_atime'} $in{'autoselect_pool'}/$in{'value_new'}";
    #&mess($do);
         $r=&exe("$do");

          if ($r ne '') {  print $r; sleep(2); }

   }
   sleep(1);


  ##################################
   #set defaults for windows sharing
   #########

   print "<br>done..</b>";
   if ($in{'autoselect_crypt'}=~/on/) {
         print "<br><b>please backup key and try a lock/unlock!</b>";
         sleep(5);
   }

   #info
   if ($in{'value_info'} ne "" ) {
        $in{'value_info'}=~s/ +/_/g;
        &exe("zfs set info:=$in{'value_info'} $in{'autoselect_pool'}/$in{'value_new'}");
        print "<br>zfs set info:=$in{'value_info'} $in{'autoselect_pool'}/$in{'value_new'}<br>";
   }

   # created?
   $r=&exe("zfs list -H -o name $in{'autoselect_pool'}/$in{'value_new'}");
   chomp $r;
   if ($r eq "$in{'autoselect_pool'}/$in{'value_new'}")  {
           print "<br>ok";   sleep(1);
           $in{'autoselect_pool'}="";
           $in{'l3'}="";
           reload();
   }

   &mess("error<hr>$in{'autoselect_pool'}/$in{'value_new'} was not created");

}





###############################################
#end of my script, do not delete the line below
1;