#!
use strict;         # check for proper code

###############
sub my_action {
###############     build actions according to this template

  &log_end;
  print "<script language='javascript'>document.getElementById('hl').innerHTML='Keysplit overview'</script>\n";

  my (@keys,$sel,$t,$l,$r,$k,@v);
  $r=&exe("zfs get -H -t filesystem name,info:,encryption");

  # z1/enc3     name        z1/enc3         -
  # z1/enc3     info:       123_4           local
  # z1/enc3     encryption  aes-256-gcm     -             # or off

  my %fs;                 # fs values
  $fs{'_hashname'}="fs";

  my @l=split(/\n/,$r);   # list

  foreach my $l (@l) {
     @v=split(/\s+/,$l);                  # NAME    PROPERTY    VALUE        SOURCE

     # allfs
     if (!($fs{'allfs'}=~/\b$v[0]\b/)) {
          $fs{'allfs'}.="\t$v[0]";              # tablist
     }

     # enc
     if ($v[1] eq "encryption") {
        $k=$v[0]."_enc";
        $fs{$k}=$v[2];
     }

     # info
     if ($v[1] eq "info:") {
        $k=$v[0]."_info";
        $fs{$k}=$v[2];
     }

     #&print_array(@v);

  }
  $fs{'allfs'}=~s/^\t+//;

  # local web-gui keys
  @t = glob("$wpath/_log/keys/*.*");
  $fs{'keylist_cs'}=join("\n",@t);

  # member key view per filesystem
  $fs{'keylist'}=&exe('keylist');

  # &mess($fs{'keylist'});
  # local (pve~192.168.2.71) [/var/web-gui/cs_server/keys]
  # pve~192.168.2.71~z1~data~enc2.keypart1
  # pve~192.168.2.71~z1~enc.keypart1
  # pve~192.168.2.71~z1~enc.keypart2;
  # w1 (192.168.2.65)[/xampp/web-gui/_log/keys]
  # pve~192.168.2.71~z1~data~enc.completekey
  # pve~192.168.2.71~z1~data~enc.keypart1
  # pve~192.168.2.71~z1~data~enc.keypart2
  # pve~192.168.2.71~z1~data~enc.keypart3
  #..
  # w2 (not set):

  @t=split(/\n/,$fs{'keylist'});
  foreach my $t (@t)  {
        if ($t=~/local \(/) {
           $fs{'local_host'}=$t;   $fs{'local_host'}=~s/ *\[.*//;
           $fs{'local_path'}=$t;   $fs{'local_path'}=~s/.*\) *//;
        }
        if ($t=~/w1 \(/)  {
           $fs{'w1_host'}=$t;     $fs{'w1_host'}=~s/ *\[.*//;
           $fs{'w1_path'}=$t;     $fs{'w1_path'}=~s/.*\) *//;
        }
        if ($t=~/w2 \(/)  {
           $fs{'w2_host'}=$t;     $fs{'w2_host'}=~s/ *\[.*//;
           $fs{'w2_path'}=$t;     $fs{'w2_path'}=~s/.*\) *//;  $fs{'w2_path'}=~s/:/-/;
        }
  }

 # print "<pre>$t</pre>";
 #&mess($t);

  print <<EoF;
<pre><b>Encrypted filesystems with keysplit (member view of keys)</b>

</pre>
EoF

  # headers
  my $data="<b>Filesystem</b>\t<b>Encryption</b>\t<b>Info</b>\t<b>$fs{'local_host'}</b><br>$fs{'local_path'}\t<b>$fs{'w1_host'}</b><br>$fs{'w1_path'}\t<b>$fs{'w2_host'}</b><br>$fs{'w2_path'}\t<b>Can_unlock</b>\t<b>cs web-gui (Windows)</b><br>[$wpath/_log/keys]\n";

  my @fs=split(/\t/,$fs{'allfs'});
  if (@fs==0) { $fs[0]="-none-"; }

  my ($kl,$f,$cpl,$enc);
  my $member=$in{'member'};

  foreach my $fs (@fs) {

    $f=$fs; $f=~s/\//~/g;
    $cpl="-";
    $kl="";

    #fs
    $data.="$fs\t";

    #Enc
    $k=$fs."_enc";
    $data.="$fs{$k}\t";
    $enc=$fs{$k};

    #info
    $k=$fs."_info";
    $data.="$fs{$k}\t";

    #local keys
    $t=$fs{'keylist'}; $t=~s/w1 .*//s;
    if ($t=~/$member~$f.keypart1/s) { $kl="K1,";   $cpl.="K1"; }
    if ($t=~/$member~$f.keypart2/s) { $kl.=" K2,"; $cpl.="K2"; }
    if ($t=~/$member~$f.keypart3/s) { $kl.=" K3,"; $cpl.="K3"; }
    if ($t=~/$member~$f.complete/s) { $kl.=" C,";  $cpl.="C";  }
    $kl=~s/,$//;
    $data.="$kl\t";

    #w1 keys
    $kl="";
    $t=$fs{'keylist'}; $t=~s/.*w1 //s; $t=~s/w2 .*//s;
    if ($t=~/$member~$f.keypart1/s) { $kl="K1,";   $cpl.="K1"; }
    if ($t=~/$member~$f.keypart2/s) { $kl.=" K2,"; $cpl.="K2"; }
    if ($t=~/$member~$f.keypart3/s) { $kl.=" K3,"; $cpl.="K3"; }
    if ($t=~/$member~$f.complete/s) { $kl.=" C,";  $cpl.="C";  }
    $kl=~s/,$//;
    $data.="$kl\t";

    #w2 keys
    $kl="";
    $t=$fs{'keylist'}; $t=~s/.*w2 //s;
    if ($t=~/$member~$f.keypart1/s) { $kl="K1,";   $cpl.="K1"; }
    if ($t=~/$member~$f.keypart2/s) { $kl.=" K2,"; $cpl.="K2"; }
    if ($t=~/$member~$f.keypart3/s) { $kl.=" K3,"; $cpl.="K3"; }
    if ($t=~/$member~$f.complete/s) { $kl.=" C,";  $cpl.="C";  }
    $kl=~s/,$//;
    $data.="$kl\t";

    # unlock?
#print "$cpl<br>";
    $t="no";
    if ($cpl=~/C/) { $t="<b>yes</b>"; }
    if (($cpl=~/1/) && ($cpl=~/2/) && ($cpl=~/3/))    { $t="<b>yes</b>"; }

    if ($enc eq "off") { $t="-";  }
    $data.="$t\t";

    #cs keys
    $kl="";
    $t=$fs{'keylist_cs'};
    if ($t=~/$member~$f.keypart1/s) { $kl="K1,";   $cpl.="K1"; }
    if ($t=~/$member~$f.keypart2/s) { $kl.=" K2,"; $cpl.="K2"; }
    if ($t=~/$member~$f.keypart3/s) { $kl.=" K3,"; $cpl.="K3"; }
    if ($t=~/$member~$f.complete/s) { $kl.=" C,";  $cpl.="C";  }
    $kl=~s/,$//;
    $data.="$kl\t";

    $data.="\n";
  }

  # table1 key overview
  print &list2table($data);

#################
#cs keys, table2
################

print <<EoF;
<pre>

<b>Overview of all keys available in the cs keyfolder $wpath/_log/keys </b>
Backup them in a save place or print them out and distribute keys locally on member and W1/W2

</pre>
EoF

# header
my $csdata="<b>Member</b>\t<b>Filesystem</b>\t<b>Keys</b>\t<b>Can unlock</b>\n";

@t=split(/\n/,$fs{'keylist_cs'});
if ($fs{'keylist_cs'} eq "") { $t[0]="-none-"; }

###############################
# step1, get all cs filesystems
###############################
my ($m,$fs,@p);
foreach my $t (@t) {

    $kl="";
    $t=~s/.*\///;

    $fs=$t;
    $fs=~s/\.keypart.$//;  $fs=~s/\.completekey$//;

    #list of cs
    if (!($fs{'fslist_cs'}=~/\b$fs\b/s)) {
       $fs{'fslist_cs'}.="$fs\n";
    }

#print "$t -> $fs<br>";
    # keys per fs
    $k=$fs."_cskeys";
    if ($t=~/$fs.keypart1/s) { $kl.=" K1,"; if (!($fs{$k}=~/K1/)) { $fs{$k}.=" K1,"; }  }
    if ($t=~/$fs.keypart2/s) { $kl.=" K2,"; if (!($fs{$k}=~/K2/)) { $fs{$k}.=" K2,"; }  }
    if ($t=~/$fs.keypart3/s) { $kl.=" K3,"; if (!($fs{$k}=~/K3/)) { $fs{$k}.=" K3,"; }  }
    if ($t=~/$fs.complete/s) { $kl.=" C,";  if (!($fs{$k}=~/C/))  { $fs{$k}.=" C,";  }  }


}
$fs{'fslist_cs'}=~s/\n$//s;                # localhost~127.0.0.1~tank~enc
#&print_hash(%fs);

########################
# step2, show keys per fs
########################

my ($m,$fs,@p);
my @fslist=split(/\n/,$fs{'fslist_cs'});

#&print_array(@fslist);
# [0] -> 'localhost~127.0.0.1~tank~enc'
# [1] -> 'localhost~127.0.0.1~xx.txt'
# [2] -> 'pve~192.168.2.71~z1~data~enc'

foreach my $k (@fslist) {

    # print "$k<br>";

    # member
    @p=split(/~/,$k);
    $csdata.="$p[0]~$p[1]\t";                # member
    $m="$p[0]~$p[1]";

    shift(@p); shift(@p);                    # remove member~ip
    # filesystem
    $fs=join('~',@p);
    $csdata.="$fs\t";

    # keys                                   # keys for fs
    $k="$m~$fs\_cskeys";
    $fs{$k}=~s/,$//;
    $csdata.="$fs{$k}\t";

    #complete
    $t="no";
    if ($fs{$k}=~/C/) { $t="<b>yes</b>"; }
    if (($fs{$k}=~/1/) && ($cpl=~/2/) && ($cpl=~/3/))    { $t="<b>yes</b>"; }
    $csdata.="$t\t";

    $csdata.="\n";
}

# table2 cskey overview
print &list2table($csdata);

&log_end;

if ($log_on) {  print '<br><br>Hash %fs<br>';   &print_hash(%fs); }

print "<br>";
exit;


} #/ my_action





###############################################
#end of my script, do not delete the line below
1;