sub my_action {
###############
    my ($out);

 # header
 print "<script language='javascript'>\$('#hl').html('Create ZFS volume on $in{'member'}\:$current{'on'}')</script>\n";

    # 1. example1 multiline variable
    #################################

print "<b>create a Volume:</b><br><i>names must be unique</i><br><br>";


##############################

if ($in{'submit_ok'} ne "create new volume") { $in{'answered'} =""; }                      # not klicked on submit but on autoselect
if ($in{'answered'})  { &my_do_volume; }         # do it
&my_ask_volume;                                                                 # ask user


} #/ my_action




####################
sub my_ask_volume {
####################
   my ($t,@t,$z);

  #first call
  if ($in{'autoselect_pool'} eq "") {
    $in{'autoselect_pool'}=$zfs{'datapools'};
    $in{'autoselect_pool'}=~s/\t.*//;              #first pool
  }

  &ask('begin');
  &ask('autoselect_pool','Select pool ',$zfs{'datapools'},$in{'autoselect_pool'});
  &ask('autoselect_fs','Select parent filesystem',&zfslib_list('filesystem',$in{'autoselect_pool'}),$in{'autoselect_fs'});
  &ask('value_file','Name of new volume (optional)</b><br>Keep empty to use iscsi_time() where a LU Guid is part of zvol name',$in{'value_file'},"w50");
  &ask('value_size','Enter size',$in{'value_size'},"w50");
  &ask('select_unit','Select correct size unit, use binary base like MiB, GiB as default','KiB = 1024 bytes,MiB = 1024^2 bytes,GiB = 1024^3 bytes,TiB = 1024^4 bytes,PiB = 1024^5 bytes,EiB = 1024^6 bytes,KB = 1000 bytes,MB = 1000^2 bytes,GB = 1000^3 bytes,TB = 1000^4 bytes,PB = 1000^5 bytes,EB = 1000^6 bytes','GiB = 1024^3 bytes');
  &ask('select_block','Select block size ','512bytes,1KB,2KB,4KB,8KB,16KB,32KB,64KB,128KB','64KB');
  &ask('checkbox_thin','thin provisioned ?','yes','yes');
  &ask('confirm','create new volume',"Are you really sure to do that ?");


#list volumes
    $out="<br><br><b>List of all volumes, Volsize is a binary unit ex 10G means 10GiB<b>:<br><br>";
    print "<pre class='tt'>$out</pre>";                      # output text + reply  preformatted in style tt

    $out="\n\n".&exe("zfs list -o name,used,avail,refer,volsize,lu:guid -t volume");                  # call system
    $out=~s/\n\s+/\n/gs;
    $out=~s/ +/\t/gs;
    print &list2table($out,'100%,200px');

  #show pools:
    print "\n\n<br><br><b>zpool list:</b><br><br>\n";
    $r=&exe("zpool list");
    $r=~s/\n\s+/\n/gs;
    $r=~s/  +/\t/gs;
    print &list2table($r);


  &log_end;

  exit;
} # end sub



##################
sub my_do_volume {
##################
#&print_hash(%in);

my ($unit,$size,$block,$vol,$s);

if ($in{'autoselect_fs'} eq "") { &mess("A parent filesystem is needed"); }

$in{'value_file'}=~s/ /_/g;
$in{'value_file'}=~s/[^0-9a-zA-Z\_\-\/]//g;

if ($in{'value_file'} eq "")   { &mess("A volume name is needed"); }

$size=$in{'value_size'};
$unit=$in{'select_unit'};   # no, use absolute number of bytes
$unit=~s/ *=.*//;

#&mess("$size$unit");
$size=&validate($size,"r+","size");

# get exact number in bytes
$size=&b_convert("$size$unit","","b");

# debug
#&mess($size);

$block=$in{'select_block'};
$block=~s/bytes//;

#thin provisioned
$s="";
if ($in{'checkbox_thin'} ne "") {
   $s=" -s";
}

$vol=$in{'autoselect_fs'}."/$in{'value_file'}";
$r=&exe("zfs create$s -V $size -b $block $vol");


if ($r) {
    &mess("Failed to create ".$in{'autoselect_fs'}."/".$in{'value_file'}." -> ".$r."<hr>hint: check if you have enough space to create this volume");
} else {
    print ("Filesystem ".$in{'autoselect_fs'}."/".$in{'value_file'}." was succesfully created");
    &reload;
}
exit;



} # end sub

###############################################
#end of my script, do not delete the line below
1;
