#!/usr/bin/perl
#
# report poolstatus based on zpool status
# any ZFS member

###############################
# part 1 - same for all reports
###############################

use strict;
use vars qw(@p %zfs %sys %disk %cfg %current @p %in @par @t $t $f %r $os $id $alertlist $alertlistf $alertlog $statlog $alertsend $statsend $alertmess $info $alert $message $text $subject $binpath $lpath $spath);

use Fcntl qw(:flock); # filelocking
$|=1;                 # keine Pufferung, no buffering

require "/xampp/web-gui/data/wwwroot/cgi-bin/admin-wlib.pl";


#process report and return results
require "/xampp/web-gui/data/menues/_lib/scripts/reports/report.lib";                                              # load my_report, set message, text and alertmess
print "message_begin=$message"."message_end\nalert_begin=$alertmess"."alert_end\nstatus_begin=$text"."status_end\n";   # end

use lib "/xampp/web-gui/data/cs_server/CGI";

use Digest::SHA::PurePerl qw(sha256_hex);
use IO::Socket::INET;                            # needed for socket in admin-wlib

###################
# end common part 1
###################


###########################
# part 2, modify per report

###############   executed via require report.lib
sub my_report {
###############
   # pool status error?

   # get cfg (auth + cfg settings like mail or upsrv) from adminlib per single report
   &get_cfg;    # with $current{'member_ip'}="";      # per member call

   my @members=split(/\t/,$current{'members'});
   my ($ip,$hi,$list,$capalert,@t,@p,$r);


   foreach my $member (@members)  {

        $text.="#######\nMember: $member\n#######\n";
        print "\nMember: $member\n";

        # if Alert enabled and alert: print alertlog
        # if Status enabled: print statlog

        # get needed infos in $text
        #zpool status
        $ip=$member; $ip=~s/.*~//;
        $current{'member_ip'}=$ip;
# &print_hash(%cfg);

        $r=&socket("hi",$ip,'5');                                # returns $on,$rh,$os
        print "hi: $r\n";
        if ($r=~/error:/s) {  $text.=" $r\n\n";  next;  }

        # NAME   SIZE  ALLOC   FREE  CKPOINT  EXPANDSZ   FRAG    CAP  DEDUP    HEALTH  ALTROOT
        # tank  4.50G   904K  4.50G        -         -     0%     0%  1.00x    ONLINE  -

        $r=&socket("zpool list",$ip);
        print "list: $r\n";
        if ($r=~/error:/s) {  $text.=" $r\n\n";  next;  }    # communication problem

        $text.="$r\n\n";                                     # pool list

        #debug
        #$text.="FAULTED";

        # check pool error
        if ($r=~/OFFLINE|DEGRADED|UNAVAIL|FAULTED|REMOVED/s) {
             $subject.="Poolproblem ";
             $alert.="1";
        } else {
             $alert.="0";
        }

        # add cap alert and pool status for bad pools
        @t=split(/\n/,$r);
        foreach my $t (@t) {
            if ($t=~/^NAME\s/)  { next; }
            @p=split(/ +/,$t);

            # cap alert 90%
            if ($p[7] >=90) {
               $subject.="Cap<10% ";
               $text.="cap alert pool $p[0] $p[7]\n";
               $alertmess.="member: $member\n$r\n";
               print "cap alert $member pool $p[0] $p[7]\n";
               $alert.="1";
            }

            $r="";
            if ($p[9] ne "ONLINE") {
               $r=&socket("zpool status $p[0]",$ip);
               if ($r=~/error:/s) {  $text.=" $r\n\n";  next;  }    # communication problem
               $alertmess.="member: $member\n$r\n";
               $text.="$r\n\n";
            }
         }
    }

    if ($alertmess ne "") { $alertmess="Alertdate: $sys{'date_us'}\n\n$alertmess\n"; }

    if ($subject eq "") { $subject="ok"; }

    print "\nreturn: $subject\n\n";
    return ($subject);          # message_begin=$subjectmessage_end
}

# eof
1;