# get_spaced.pl
# get Storage spaces infos
# windows

use strict;
my (@p,@t,$r,$p,@data,$k,$pool,$vd,@header,$n,$h,@h,$vol,$part);

&get_storagepools;                   # always
&get_virtualdisks;                   # always

#&get_volumes;                       #
#&get_partitions;

# vol and part on demand in preload

###################
# get storage pools
###################
sub get_storagepools {

  # primordial ist keinem pool zugeordnet, hier systemplatte

  $r=&exe("Get-StoragePool | ConvertTo-csv");                        # get csv data
  $win{'pool_headers'}=&csv2par($r);                                 # FriendlyName or UniqueId as key  (first value)

  # &mess($win{'pool_headers'});
  # FriendlyName,Usage,OperationalStatus,HealthStatus,ProvisioningTypeDefault,SupportedProvisioningTypes,MediaTypeDefault,ReadOnlyReason,RepairPolicy,RetireMissingPhysicalDisks,WriteCacheSizeDefault,Version,FaultDomainAwarenessDefault,ObjectId,PassThroughClass,PassThroughIds,PassThroughNamespace,PassThroughServer,UniqueId,AllocatedSize,ClearOnDeallocate,EnclosureAwareDefault,IsClustered,IsPowerProtected,IsPrimordial,IsReadOnly,LogicalSectorSize,MetadataLength,MinimumAllocationSize,Name,OtherOperationalStatusDescription,OtherUsageDescription,PhysicalSectorSize,ResiliencySettingNameDefault,Size,SupportsDeduplication,ThinProvisioningAlertThresholds,WriteCacheSizeMax,WriteCacheSizeMin,PSComputerName

  @header=split(/,/,$win{'pool_headers'});

  $t=&csv2data($r,$win{'pool_headers'},'p:FriendlyName');            # csv, headers,pre:key for %win ex p:poolname_value
  my @pools=split(/\n/,$t);

  # get win(allpools)
  foreach my $p (@pools) {
     if (!($p =~/\w/)) { next; }

     # pool,Other,OK,Healthy,Fixed,Thin Fixed,..

     $pool=$p; $pool=~s/,.*//;              # Poolname
     $win{'allpools'}.="\t$pool";

  }
  $win{'allpools'}=~s/^\t+//;

}  #/sub


  ################
  #Get-VirtualDisk
  ################
sub get_virtualdisks {

  $r=&exe("Get-virtualdisk | ConvertTo-csv");
  $win{'vd_headers'}=&csv2par($r);


  # &mess($win{'vd_headers'});
  # FriendlyName,Usage,NameFormat,OperationalStatus,HealthStatus,ProvisioningType,AllocationUnitSize,MediaType,ParityLayout,Access,UniqueIdFormat,DetachedReason,WriteCacheSize,FaultDomainAwareness,ColumnIsolation,ObjectId,PassThroughClass,PassThroughIds,PassThroughNamespace,PassThroughServer,UniqueId,AllocatedSize,FootprintOnPool,Interleave,IsDeduplicationEnabled,IsEnclosureAware,IsManualAttach,IsSnapshot,IsTiered,LogicalSectorSize,MaxIoBandwidth,MaxIops,MinimumLogicalDataCopies,Name,NumberOfAvailableCopies,NumberOfColumns,NumberOfDataCopies,NumberOfGroups,OtherOperationalStatusDescription,OtherUsageDescription,PhysicalDiskRedundancy,PhysicalSectorSize,ReadCacheSize,RequestNoSinglePointOfFailure,ResiliencySettingName,Size,TrackValidData,UniqueIdFormatDescription,WriteCacheReserveSize,PSComputerName

  @header=split(/,/,$win{'vd_headers'});

  $t=&csv2data($r,$win{'vd_headers'},'v:FriendlyName');
  my @vds=split(/\n/,$t);

  foreach my $v (@vds) {
     if (!($v =~/[a-zA-Z0-9]/)) { next; }

     # pool,Other,OK,Healthy,Fixed,Thin Fixed,..

     $vd=$v; $vd=~s/,.*//;                   # vdname
     $win{'allvds'}.="\t$vd";

  }
  $win{'allvds'}=~s/^\t+//;

  # get disks of this spce
  # Get-virtualdisk -friendlyname s1 | get-physicaldisk | ConvertTo-csv

  my @vd=split(/\t/,$win{'allvds'});
  my $dl;  # disklist
  my ($p,@p,@l,$k);

  foreach my $v (@vd) {
      $t=&exe("Get-virtualdisk -friendlyname $v | get-physicaldisk");

      # Number FriendlyName      SerialNumber MediaType CanPool OperationalStatus HealthStatus Usage        Size
      # ------ ------------      ------------ --------- ------- ----------------- ------------ -----        ----
      # 10     Msft Virtual Disk              SSD       False   OK                Healthy      Auto-Select 10 GB

      $dl="";
      @l=split(/\n/,$t);
      foreach my $l (@l) {
         if (!($l=~/^\d/)) { next; }
         @p=split(/ +/,$l);
         $dl.="$p[0],";
      }
      $dl=~s/,$//;
      $k="v:$v\_OnDisks";
      $win{$k}=$dl;
  }

} #/sub

  ############
  # Get-Volumes
  ############
sub get_volumes  {

  # DriveLetter FriendlyName  FileSystemType DriveType HealthStatus OperationalStatus SizeRemaining      Size
  # ----------- ------------  -------------- --------- ------------ ----------------- -------------      ----
  #                          Unknown        Removable Healthy      Unknown                     0 B       0 B
  # I           Volume2       NTFS           Fixed     Healthy      OK                      3.88 GB   3.91 GB
  # C                         NTFS           Fixed     Healthy      OK                    118.94 GB 475.95 GB
  # Y           Speicherplatz NTFS           Fixed     Healthy      OK                     19.82 GB  19.87 GB
  #                           FAT32          Fixed     Healthy      OK                     71.03 MB  99.21 MB
  # E           Volume1       NTFS           Fixed     Healthy      OK                      3.88 GB   3.91 GB
  # D                         Unknown        Removable Healthy      Unknown                     0 B       0 B
  #                           NTFS           Fixed     Healthy      OK                     86.31 MB    786 MB
  # Drive D is a ZFS pool

  $r=&exe("Get-volume | ConvertTo-csv");
  $win{'volume_headers'}=&csv2par($r);

  # &mess($win{'volume_headers'});
  # UniqueId,OperationalStatus,HealthStatus,DriveType,FileSystemType,DedupMode,ObjectId,PassThroughClass,PassThroughIds,PassThroughNamespace,PassThroughServer,AllocationUnitSize,DriveLetter,FileSystem,FileSystemLabel,Path,Size,SizeRemaining,PSComputerName

  @header=split(/,/,$win{'volume_headers'});

  $t=&csv2data($r,$win{'volume_headers'},'l:UniqueId');
  my @vol=split(/\n/,$t);

  foreach my $v (@vol) {
     if (!($v =~/[a-zA-Z0-9]/)) { next; }

     # pool,Other,OK,Healthy,Fixed,Thin Fixed,..

     $vol=$v; $vol=~s/,.*//;              # vollname
     $win{'allvols'}.="\t$vol";

  }
  $win{'allvols'}=~s/^\t+//;

  # reverse select  (UniqueId, DriveTypem, FileSystem and FileSystemType per DriveLetter)
  my ($i,$k,$dl,@vol);

  @vol=split(/\t/,$win{'allvols'});
#&print_hash(%win);

  foreach my $v (@vol) {

    # l:\\?\Volume{890260dc-76d4-4819-9558-3d926f2261c7}\_DriveLetter      ->         'C'
    # l:\\?\Volume{890260dc-76d4-4819-9558-3d926f2261c7}\_DriveType        ->         'Fixed'
    # l:\\?\Volume{890260dc-76d4-4819-9558-3d926f2261c7}\_FileSystem       ->         'NTFS'
    # l:\\?\Volume{890260dc-76d4-4819-9558-3d926f2261c7}\_FileSystemType   ->         'NTFS'

    $k="l:$v\_DriveLetter";
    if ($win{$k} ne "") {
        $dl="$win{$k}";   # C

        # id
        $i="dl:$dl\_UniqueId";
        $t="$v\_UniqueId";
        $win{$i}=$v;

        # type
        $i="dl:$dl\_DriveType";
        $t="l:$v\_DriveType";
        $win{$i}=$win{$t};

        # fs
        $i="dl:$dl\_FileSystem";
        $t="l:$v\_FileSystem";
        $win{$i}=$win{$t};

        # fstype
        $i="dl:$dl\_FileSystemType";
        $t="l:$v\_FileSystemType";
        $win{$i}=$win{$t};

    }
  }


} #/sub

  ############
  # Get-Partition
  ############
sub get_partitions {

  $r=&exe("Get-partition | ConvertTo-csv");
  $win{'partition_headers'}=&csv2par($r);

  # &mess($win{'partition_headers'});
  # UniqueId,OperationalStatus,Type,DiskPath,ObjectId,PassThroughClass,PassThroughIds,PassThroughNamespace,PassThroughServer,AccessPaths,DiskId,DiskNumber,DriveLetter,GptType,Guid,IsActive,IsBoot,IsDAX,IsHidden,IsOffline,IsReadOnly,IsShadowCopy,IsSystem,MbrType,NoDefaultDriveLetter,Offset,PartitionNumber,Size,TransitionState,PSComputerName

  @header=split(/,/,$win{'partition_headers'});

  $t=&csv2data($r,$win{'partition_headers'},'r:UniqueId');
  my @part=split(/\n/,$t);

  foreach my $v (@part) {
     if (!($v =~/[a-zA-Z0-9]/)) { next; }

     # pool,Other,OK,Healthy,Fixed,Thin Fixed,..

     $part=$v; $part=~s/,.*//;              # partname
     $win{'allpart'}.="\t$part";

  }
  $win{'allpart'}=~s/^\t+//;
} #/sub

  #&print_hash(%win);

  #&mess ($pools);
  ######################################
  1;