# remote functions for napp-it cs on Windows
# Copyright (c) 2010 - 2024 napp-it
# functions are autoloaded if action contains &thislib_xx() ex &zfslib_list() will autoload zfslib via require


#########
sub grouplib {  #  # allow remote management
###########################
}


##################
sub grouplib_remote_data {                # hide:
##################

#&print_hash(%in);
      # action=rgroup_data_abx.txt -> abc.txt is filename
      my $fn=time()."tmp";
      if ($in{'action'}=~/rgroup_data_\w+/) {
         $fn=$in{'action'};
         $fn=~s/rgroup_data_//;
      }

      &my_write("$tpath/$fn","$in{'file'}");

      my $l=length($in{'file'});
      print "Content-type: text/plain\r\nweb-gui-ok:$l Bytes received\n";
      exit;

    #################
}

##################
sub grouplib_remote_call {                # hide:
##################

        #############################################
        # this part is called by another ZFS server
        # to answer remote calls
        #############################################

        &print_hash(%in);      # obsolete

        # actions #########
        # do="" -> return ok:web-guo
        # do=request_membership (pw=adminpw) -> return web-gui-ok:$name=$access (access key from ip+pw)
        #############################################

        # called when:  action=rgroup by sub nasgroup_change_property in nasgroup-lib.pl
        #############


}

###########  ## log last run in jobfile /_log/jobs/id...job
sub grouplib_remote_log {
###########

  my @p1=caller(0); # this:
  my @p2=caller(1); # parent:  package, filename, line, subroutine, hasargs, wantarray, evaltext, is_require, hints, hitmask
  my @p3=caller(2);

  my $rem="$wpath/_log/remote.log";

  my (@v,$v,$n,$l,$f1,$f2,@data);
  my $info="## $sys{'hour'}:$sys{'min'} $sys{'sec'} grouplib $p1[2]: $_[0]";


  # write
  @data=();
  if (-f $rem) {
         open (F,"<$rem");
               flock(F, LOCK_EX);
               @data=<F>;
         close (F);
  }

  $info=~s/\n/<br>/gs;
  unshift(@data,"$info\n");

  if (@data > 100) {
             $t=@data-100;
             splice(@data,100,$t);
  }

  $t=join("",@data);
  open (PF, ">$rem");
          flock(PF, LOCK_EX);
          print PF "$t";
  close (PF);

}


###########################
sub grouplib_source_target {   #  get source and target of a replication
###########################

       # select_source + select_destination selected in menu jobs > create replication
#&print_hash(%in);


       my ($source_fs,$dest_fs,$source_ip,$dest_ip,$source_auth,$dest_auth);
       $source_ip=$in{'select_source'};      $source_ip=~s/.*~//;                  # use ip only
       $dest_ip  =$in{'select_destination'}; $dest_ip  =~s/.*~//;

       $source_auth=$cfg{$source_ip};
       $dest_auth=$cfg{$dest_ip};

#&mess("$source_ip -> $dest_ip<hr>$source_auth , $dest_auth");

       # source_fs
       $source_fs=&socket("zfs list -H -o name auth:=$source_auth",$source_ip,'10');                        # &socket -> cmd auth:=, ip, timeout
#mess($source_fs);
       # dest_fs
       if (source_ip eq $dest_ip) {
         $dest_fs=$source_fs;
       }  else {
         $dest_fs=&socket("zfs list -H -o name auth:=$dest_auth",$dest_ip,'10');

       }

       $source_fs =~s/\n/,/gs;                            # filesystems, commalist
       $dest_fs   =~s/\n/,/gs;

#&print_var($source_fs);

        &ask('begin','b');
        &ask('hidden','sd2','1');                            # source-dest menue 2
        &ask('hidden','dest_filesystems',$dest_fs);          # to check against new name

        print " <b style='background-color:#dddddd'>Replication from: $in{'select_source'}</b><br>";
        &ask('select_source','Source server',$in{'select_source'});
        &ask('select_src_zfs','Source Pool/ Filesystem',$source_fs,$in{'select_src_zfs'});

        print "<br><br><b style='background-color:#dddddd'>Replication to: $in{'select_destination'}</b><br>";
        &ask('select_dest','Destination server',$in{'select_destination'});
        &ask('select_dest_zfs','Destination Pool/ Filesystem<br>replicated filesystem is created below',$dest_fs,$in{'select_dest_zfs'});

        print "it is suggested to disable recursiv and create multiple jobs per filesystem";
        &ask('select_recursive','enable recursiv','no,yes');

        print "Raw send: useful to send encrypted filesystems";
        &ask('select_raw','zfs raw send','no,yes');

        print "Incremental send: only newest data (-i) or include all intermediary snapshots and clones(-I)";
        &ask('select_send_i','zfs send incremental snapshot option','-i,-I');


        ask('value_send_options','other send options',$in{'value_send_options'});
        ask('value_receive_options','other receive options',$in{'value_receive_options'});

        &ask('value_zfs_name','Name of new ZFS (empty=same)',$in{'value_zfs_name'});

        # only needed to recreate job
        &ask('value_force_id','Force jobid (to continue a former job)',$in{'value_force_id'});

        &ask('value_esxi','Include ESXi quiesce/memory snaps for ESXi ip <br>If this FS is a NFS/ESXi datastore',$in{'value_esxi'});

        print "<br> <b style='background-color:#dddddd'>Options:</b><br><br>";
        &ask('select_type','Replication type','zfs send via netcat',$in{'select_type'});


        #keep
        print "<br>";
        $t="hours:n, (hourly snap per last n hours)<br>days|months|years:n, (one per last n days|months|years)<br>ex hours:24,days:32,months:12,years:2";
        &ask('value_keep',"Keep target repli snaps (commalist of values or char)<br>$t",$in{'value_keep'});
        &ask('value_hold','Hold target repli snaps for n (days) or n s (snaps)<br>ex 8 = 8days or 8s = 8 snaps, keep empty to hold last two snaps<br><br>Keep and hold are both respected',$in{'value_hold'});

        print "<br><br><b style='background-color:#dddddd'> Timetable</b><br><br>\n";


        &ask('select_month','Month (1..12)','every','every');
        &ask('select_day','Day (sun..sat 1..31)','every,sun,mon,tue,wed,thu,fri,sat,mon-fri,mon-sat,sat-sun,first-sat,first-sun,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31','sun');
        &ask('select_hour','Hour (0..23)','every,every-2,every-2BC,every-3BC,0,3,6,9,12,15,18,21','0');
        &ask('select_min','Minute','every,every-3,every-5,every-10,every-15,every-20,every-30,0,15,30,45,once','0');
        print "<br>\n";
        &ask('select_status','Status','manual,active','manual');

        print "<a href=\"#\" onclick=\"\$('.info').toggle();\"><img src=\"/_doc/menu/ico/i16.png\"></a>\n";
        print "<div class='info'>Info: 0-3-5 means 0, 3 and 5<br>every-2 (hour) means every two hours<br>every-1BC (hour) means every hour between 7-12 and 13-19 hour (ABCD, each 6 hours from 0..23)";
        print "<br>every month can be every, every-2, every-3,every-4, every-6";
        print "<br>every day can be every, every-2, every-3, every-7, every-14";
        print "<br>every hour can be  every, every-2, every-3, every-4, every-6, every-12, opt followed by ABCD - A=0..5, B=6..11, C=12..17, D=18..23";
        print "<br>every minute can be every, every-3, every-5, every-10, every-15, every-20, every-30";
        print "<br>minute=once means: execute job once after each reboot";
        print "<br><br>Your source/target must have different hostnames and should not change IP";
        print "<br>Your target ZFS is read-only after replication. After disabling replication, you can set it to read/write and use it at usual";
        print "</div><br><br>";

        &ask('end');    # create job , start it manually
        print "<br>Replication is speed optimized and unencrypted. <br>If you want to replicate over unsecure networks like Internet, a VPN link (Wireguard) or encrypted raw send is suggested!<br>\n";




#print_array(@source);


}


sub grouplib_kb {
#################
      my $w1=$_[0]; $w1=~s/ //g;
      if ($w1=~/K/) { $w1=~s/K//;  }
      if ($w1=~/M/) { $w1=~s/M//; $w1=$w1*1000; }
      if ($w1=~/G/) { $w1=~s/G//; $w1=$w1*1000000; }
      if ($w1=~/T/) { $w1=~s/T//; $w1=$w1*1000000000; }
      if ($w1=~/P/) { $w1=~s/P//; $w1=$w1*1000000000000; }
      return ($w1);
}

#######################
 sub grouplib_nasgroup_overview {            # print group overview
 ############### print overview if user zfs
    my ($group,@z,$d,$url,$u,$n,$r,@w,@g,$w,$out,$ask,$host,$s,$z,$p,$count);
    $count="0";
    #set property -> answered
            if ($in{'answered'}) { &grouplib_change_property; }

    #delete -> answered
            if ($in{'action'} eq "del-nasgroupmember") { &grouplib_change_property; }

        #delete -> answered
            if ($in{'action'} eq "add-nasgroupmember") { &grouplib_ask_property; }

    #url
    $url="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;type==type=\&amp;action==action=\&amp;list==list=\&amp;prop==prop=\&amp;old==old=\"=ask=>=text=</a>";
    $ask=" onclick=\"return(confirm(\'=ask2=?\'))\"";

    ##############################
    #read list of groups-members
    $t="$wpath/_log/group";
    @t=();
    &read_dir("$t","t");

    foreach $t (@t) {
                if (!($t=~/~\d+\.\d+\.\d+\.\d+\.txt/)) { next; }               # no group member
                if ($t=~/localhost~127.0.0.1.txt/)     { next; }               # always first

                $t=~s/\.txt$//;
                $t=~s/ +//g;                                                   # in case of spaces in membername
                push (@g,"$t");                                                # member~ip
    }

    @g=sort(@g);
    unshift (@g,'localhost~127.0.0.1');                                        # always first, other sorted

#test
#&print_array(@g); # list of members;

    my $member;

    foreach my $g (@g) {
        @w=();
        @w=split(/\~/,$g);

        if (!($w[1]=~/\d+\./)) { next; }                #  ip

        $member="$g";
        #&mess($member);

        #ask remote hostname
        $r=&socket("rh auth:=$cfg{$current{'member_ip'}}","$w[1]","3");  #ask,ip,timeout, do not &mess on errors
        &log_add($r);

#&print_hash(%current);
#print "$g -> $r<br>auth:=$cfg{$current{'member_ip'}}";
#&mess("$g -> $r<hr>$cfg{$current{'$member_ip'}}");

        #parse r
        if ($r=~/auth error/s) {
           $r="authentication error";
        } else {
           if (!($r=~/\w+:\w+/)) {  $r="off, ip forbidden or timeout"; }  #
        }
        $g.="\t$r";                    # add online state/hostname

        # groupname -> link. show members (details) -> "prop"
        # +ZFS,SNAP.PID
        ################

        $z=$url;                       # for zfs list
        $s=$url;                       # for snaplist
        $p=$url;                       # for pslist

        ## ZFS, Snaps and Processes
        $z=~s/=text=/ZFS /;
        $z=~s/=list=/details/;
        $z=~s/=prop=/$member/;
        $z=~s/=action=/remote-details/;
        $z=~s/=type=/zfs/;
        $z=~s/=old=//;
        $z=~s/=ask=//;

        $s=~s/=text=/Snaps /;
        $s=~s/=list=/details/;
        $s=~s/=prop=/member/;
        $s=~s/=action=/remote-details/;
        $s=~s/=type=/snapshot/;
        $s=~s/=old=//;
        $s=~s/=ask=//;

        $p=~s/=text=/Pid /;
        $p=~s/=list=/details/;
        $p=~s/=prop=/$member/;
        $p=~s/=action=/remote-details/;
        $p=~s/=type=/ps/;
        $p=~s/=old=//;
        $p=~s/=ask=//;
        $g.="\t-";

        #$g.="\t $z / $s / $p";        #todo

#online and status
#&print_hash(%cfg);

       # auth
       $t="$wpath/_log/group/$member.txt";
       $t=&my_read($t);
       $t=~s/\s//gs;                # no spaces or nelines
       $t=substr($t,0,5);
       $g.="\t$t ...";

       # opt status of other napp-it appliances
       #$t= @data=('ip',192.2.2.2','action','rgroup');

       #$t=&grouplib_ask_post("ip","$w[1]","action"."rgroup");
       #$g.="\t$t"; # tod0
       $g.="\t-";

       # delete member
       if ($w[1]=~/\d+\.\d+\.\d+\.\d+/) {
          $n="delete";
          $d=$url;
          $d=~s/=text=/delete/;
          $d=~s/=action=/del-nasgroupmember/;
          $d=~s/=old=/$member/;
          $d=~s/=ask=/$ask/;
          $d=~s/=ask2=/delete group-member $member ?/;
          $d=~s/=list=//;
          $d=~s/=prop=//;

          # no del link with 127.0.0.1
            if ($w[1] eq "127.0.0.1")  {$d="-"; }
       }

       # add delete option
         $g.="\t$d";

    }

#test
#&print_array(@g);


   #show as table
   $out=join("\n",@g);

    $out="<b>group-members\t<b>remote hostname</b>\t<b>details</b>\t<b>auth</b>\t<b>status</b>\t<b>action</b>\n$out";  # header
    print &list2table($out,'100%,180px,180px');

    ##
    #add new group member
    $r=$url;
         $r=~s/=text=/<b>++ add ZFS server <\/b>/;
         $r=~s/=list=//;
         $r=~s/=prop=/add-nasgroupmember/;
         $r=~s/=action=/add-nasgroupmember/;
         $r=~s/=old=//;
         print "<br>$r";

    ##


   #remote napp-it details
   #if ($in{'action'} eq "remote-details")     { &grouplib_nasgroup_details; }


   #popup/ edit-window
  # if ($in{'action'} =~/add/)                          { &grouplib_ask_property;  }

    return;

 } #/sub




#######################
 sub grouplib_nasgroup_details {            # hide: show status of remote napp-it server
#######################
    my ($group,@z,$url,$u,$n,$r,@w,@g,$w,$out,$ask);

    # show as table

    if ($in{'type'} eq "snapshot") {
         $in{'prop'}=~s/\s//g;
         $out="<b>ZFS of $in{'prop'} </b>\tUsed\tAvail\tRefer\tMounted";
         $r=&grouplib_ask_remote_snaplist($in{'prop'},,"grouplib_nasgroup_details 1916");
    }
    if ($in{'type'} eq "zfs") {
         $in{'prop'}=~s/\s//g;
         $out="<b>ZFS of $in{'prop'} </b>\tUsed\tAvail\tRefer\tMounted";
         $r=&grouplib_ask_remote_zfslist($in{'prop'},,"grouplib_nasgroup_details 1921");
    }
    if ($in{'type'} eq "ps") {
         $in{'prop'}=~s/\s//g;
         $out="<b>PID's of $in{'prop'}\tCommand (storage related only)</b>";
         $r=&grouplib_ask_remote_pslist($in{'prop'},,"grouplib_nasgroup_details 1926");
         $r=~s/;;/\n/gs;
    }

    $r=~s/,/\n/gs;
    $out.="\n$r";

    print "<br><br>\n";
    print &list2table($out,'','sort2');
}


#######################
sub grouplib_ask_property {        #hide:
#######################

    ################################
    # create form to edit a property
    ################################

    my ($ask,$close,$form,$info,$t,$opt,$r,$do,$hn);
    $close="<a href=\"/cgi-bin/admin.pl?id=$in{'id'}\&amp;action=\&amp;member=$in{'member'}&amp;l1=$in{'l1'}\&amp;l2=$in{'l2'}\&amp;l3=$in{'l3'}\&amp;list=$in{'list'}\&amp;zfs=$in{'zfs'}\"><b>\&nbsp;cancel\&nbsp;/close\&nbsp;</b></a>";


    #add nas group-member
    ######################
    if ($in{'action'} eq "add-nasgroupmember") {

        @t=split(/\t/,$current{'members'});
        if ((@t>=3) && ($sys{'commercial'} ne "yes")) { &mess("More than 3 members only possible in a commercial Pro edition"); }
        $do="1";
        $form="<table><tr><td>ip: </td><td><input type='text' name='ip' value='192.168.1.' style='width: 100px'></td>";
        $form.="</tr><tr>";
        $form.="<td>member name: </td><td><input type='text' name='membername' value='' style='width: 100px'></td>";
        $form.="</tr><tr>";
        $t=&get_sha_hash(time());

        $form.="<td>auth: 256B SHA (0-0a-f) </td><td><input type='text' name='pw' value=\"$t\" style='width: 400px'></td>";
        $form.="</tr></table>";

        $info="Enter ip, membername and auth (must be the same as in server.auth on this server)<br>You can readd a member with same ip and different membername<br>";
    }


     ### form ###
     if ($do) {
        print &ask_pop("$form","$info","$opt");
     }

} #/sub





 ##############################
 sub grouplib_change_property {                 #hide:
 ##############################
 my ($r,$s,$t,$do,$aid,$n);

 # this part is called after user have edited a property (ex by form &ask_property above) and this change should happen now
 ##########################################################################################################################


  #del-nasgroup_member
  if ($in{'action'} eq "del-nasgroupmember") {
        $do="1";

        # delete file _log/group/$in{'old'}.txt
        $n="$wpath/_log/group/$in{'old'}.txt";
        if (-f $n) { unlink ($n); }

        $in{'action'}="";
        &reload();
  }

  #add member to nas group
  if ($in{'action'} eq "add-nasgroupmember") {

        my @files = glob("$wpath/_log/group/*.txt");

        $do="1";
        print "<br>please wait..\n";

        $in{'prop'}="'".$in{'prop'}."'";
        $in{'prop'}=~s/\'+/\'/g;
        $in{'ip'}=~s/[^0-9\.]//g;
        $in{'pw'}=~s/\s//g;

        $in{'membername'}=~s/[^a-z0-9A-Z\_\- ]/_/g;
        $in{'membername'}=~s/ +/_/g;

        if (!($in{'ip'}=~/^\d+\.\d+\.\d+\.\d+$/))   { &mess ('please enter a valid ip'); }
        if (!($in{'membername'}=~/\w+/))            { &mess ('please enter member name of remote server'); }
        if (!($in{'pw'}=~/\w+/))                    { &mess ('please enter an auth value for access to this server');   }

        # only one member per ip
        my @files = glob("$wpath/_log/group/*.txt");
        foreach my $file (@files) {
          if ($file=~/~$in{'ip'}/) { unlink($file);  }
        }

        $in{'membername'}=lc($in{'membername'});
        $file="$wpath/_log/group/$in{'membername'}"."~$in{'ip'}.txt";
        &str2file("$in{'pw'}",$file);                       # auth

        $in{'action'}="";
        &reload();
        exit;

        @post=("action","rgroup");
        $r=&grouplib_ask_post($in{'ip'},$sys{'port'});   # ip, port, par1,val1,par2,val2

        # $t="$perl -e 'print\"GET /cgi-bin/admin.pl?action=rgroup   HTTP/1.0\n\n\"' | $nc $in{'ip'} $sys{'port'}";

        if ($r=~/refused/s)         { &mess ("host $in{'ip'} is not responding on port $sys{'port'}"); }
        if (!($r=~/web-gui-ok:/s))  { &mess ("host $in{'ip'} is not a napp-it server<br>$t<hr>reply: $r"); }

        #request membership
         ###################

                # ask_remote
                # do=Larry%20Bird&age=35&pass=testing ,ip

                $in{'pw'}=~s/[^a-zA-Z0-9\,\.\-\;\:\_\+\#]//g;

                $n=`hostname`;
                chomp($n);

                $t="action=rgroup&do=request_membership\&pw=$in{'pw'}\&hostname=$n";

                # handled by -> &remote_call in admin.pl
                $r=&grouplib_ask_remote("$t","$in{'ip'}");

                # if ok: r="ok:gid" or r="wrong pw"
                if ($r=~/wrong/) { $r=~s/.*://s; &mess("$r");}

                #wenn okj dann ..ok:hostname=accessid
                $n=$r; $n=~s/^.*://s; $n=~s/=.*//;
                $aid=$r; $aid=~s/^.*=//s; $aid=~s/\s//gs;


                #write access id to file ip.txt
                $file="$wpath/_log/group/$n"."~$in{'ip'}.txt";
                &str2file("$aid",$file);

                $in{'action'}="";
                &reload();

  }  #/nasgroup

} #/sub


###########
sub grouplib_ask_post {                          #
###########
    #use LWP::UserAgent;                         #in admin.pl
    #use HTTP::Request::Common qw(POST);


    my @data=@_;                         # @data=('ip',192.2.2.2','action','rgroup');

    # ex call via  &post('ip',$ip,'key',$value,..);

    # @data=('ip,'timeout','action','rgroup','par2','val2',..)
    # bergabe array via &sub(@data);

    #use LWP::UserAgent;
    #use HTTP::Request::Common qw(POST);
    #use URI::Escape;

    # my $data = '{                                        # " in "key" or "value" is required
    #   "name": "John Doe",
    #   "age": 30
    # }';

    # URL des Webservers
    #my $url = 'https://www.example.com/api/endpoint';

    # User Agent erstellen
    #my $ua = LWP::UserAgent->new();

    # Data escaped
    # my $data_escaped = uri_escape($data);

    # Request erstellen
    #my $request = POST $url,
    #    Content => $data_parsed,               # length wird automatisch ermittelt
    #    Content_Type => 'text/plain',

    # Request senden
    #my $response = $ua->request($request);

    # Fehlerbehandlung
    #if ($response->is_error()) {
    #..

    # decode
    # use URI::Escape;

    #my $data_encoded = 'some%20text%2Bwith%20spaces%26symbols';
    #my $data_decoded = uri_unescape($data_encoded);


    shift @data;               # opt remove first two elements, otherwise use $ip=$data[1]

    my $ip =shift @data;
    my $url="http://$ip\/cgi-bin/admin.pl";

    my %data = ();  # Create an empty hash to store URL parameters

    # Populate the hash with key-value pairs (ensure `@data` is defined with key-value pairs)
    my $i = 0;
    foreach my $d (@data) {
        if ($i % 2 == 0) {
            $data{$d} = '';  # Assign empty string as initial value (optional)
        } else {
            $data{$data[$i - 1]} = $d;
        }
        $i++;
    }

    #&print_array(@data);
    #&print_hash(%data);

    $timeout=20;                 # default

   # large data, use higher timout

   my $len=length($data_escaped);
   if ($len > 64 * 1024)   { $timeout=10; }             # 64K
   if ($len > 256 * 1024)  { $timeout=15; }             # 256K
   if ($len > 1024 * 1024) { $timeout=20; }             # 1M

    # user agent
    my $ua = LWP::UserAgent->new;

    #timeout
    $ua->timeout($timeout); # post Timeout nach 120 Sekunden

    # request ex
    # my $request = POST "http://$ip\:$port/cgi-bin/admin.pl", [action=>rgroup, age => 24];

    # length is auto calculated, content-type for cgi
    # %data is a hash reference (\%data)

    my $request = POST $url,
        Content => \%data,
        Content_Type => 'application/x-www-form-urlencoded';

    my $response = $ua->request($request);                   # send


    my $headers= $response->headers_as_string;               # headers only
    my $body= $response->content;                            # body
    $body   = uri_unescape($body);

    #Connection: close
    #Date: Sun, 25 Feb 2024 14:54:05 GMT
    #Server: Apache
    #Content-Type: text/html
    #Client-Date: Sun, 25 Feb 2024 14:54:09 GMT
    #Client-Peer: 192.168.2.203:80
    #Client-Response-Num: 1
    #Client-Transfer-Encoding: chunked
    #Link: ; rel="icon"; type="image/x-icon"
    #Link: ; rel="stylesheet"; type="text/css"
    #Refresh: 3600;url=/cgi-bin/admin.pl?action=logout_admin
    #Title: omnios // ZFS appliance
    #--------------------------
    #Content-type: text/plain
    #web-gui-ok:OmniOS r151046z ..

    #<body>..</body> in $body

    #&mess("$data<hr>$headers<hr>$body");

    return ("$headers<hr>$body");

}

#########################
sub grouplib_ask_socket {        # max 32 , port 63000
#########################
  my $ip   =$_[0];
  my $data =$_[1];
  my $auth ="";                   # authvalue, add auth:=xx to data (auth in group/host~ip.txt)

  my @files = glob("$wpath/_log/group/*.txt");

  foreach my $file (@files) {
      if ($file=~/~$ip\.txt/) {
         open my $file, "<", "$file";       # file is GLOB nn warning after open ?
                $auth = <$file>;            # first line with hash
         close $file;
      }
  }
  if ($auth eq "") { return("error: auth not found"); }

  $data.=" auth:=$auth";
  # via sub socket in adminwlib

  $current{'member_ip'}=$ip;
  my $r=&exe($data);
  return ($r);

}

#EoF ######################
# do not remove line below (return true)
1;