#!
# keyserver lib
# (c) Guenther Alka, 2019-2024
# 29.may.2024


 #################      # split in 3 parts
 sub get_keysplit {
   my $key=$_[0];

   my $len=length($key);
   if ($len <8) { &mess("keysplit error: min key length=8 char"); }

   $len=int(length($key)/3);

   my $k1=substr($key,0,$len);
   my $k2=substr($key,$len,$len);
   my $k3=substr($key,$len*2);

   #&mess("$key<hr>$k1<br>$k2<$k3>");
   return("$k1","$k2","$k3");
 }





#############
sub get_random_ascii {
#############
  my ($t);
  my $n=$_[0];
  $n=~s/\D//g;
  if (!($n>0)) { $n="32"; }

  my @chars = ("A".."Z", "a".."z", "0".."9");
  my $string;
  $string .= $chars[rand @chars] for 1..$n;

  #&mess($string);
  return ($string);
}




###################
sub save_key_local {        # key and part 1-3
###################

   # when an enc fs is created, complete key and keypart is in keyfolder
   # you xan backup and delete them then
   # copy key or keyparts then either to a server in ./cs_server/keys or a wenserver unser ./cgi-bin/cs/keys

   my $keyfolder="$wpath/_log/keys";     # always, copy to https cgi-bin/cs/keys or cs_server/leys when needed
   if (!(-d $keyfolder)) { &mess("need keyfolder"); }

   #keyfile
   my $fn=$in{'autoselect_pool'};
   $fn=~s/\//~/g;   # tank/data -> tank~data

   my $keyfile="$keyfolder/$in{'member'}\~$fn\~$in{'value_new'}.completekey";

   # write keyfile
   &my_write($keyfile,$in{'value_crypt1'});

   # get split
   my @k=&get_keysplit($in{'value_crypt1'});               # keyparts
   #&print_array(@k);

   # write key parts kp1, kp2, kp3
   $t=$keyfile; $t=~s/\.completekey/.keypart1/;  &my_write($t,$k[0]);   # keypart1
   $t=$keyfile; $t=~s/\.completekey/.keypart2/;  &my_write($t,$k[1]);   # keypart2
   $t=$keyfile; $t=~s/\.completekey/.keypart3/;  &my_write($t,$k[2]);   # keypart3

 }


############
1;