#!
# (c) napp-it

# request other job via ``

use strict;
use Fcntl qw(:flock);                                          # filelocking
$|=1;                                                          # keine Pufferung, no buffering

use vars qw($wpath $opt $dpath $tpath $ref $par $id $action $f $t @t $p @p %current $error $info);

$wpath="/xampp/web-gui";
$dpath="/xampp/web-gui/data";
$tpath="/xampp/web-gui/tmp";

use lib "/xampp/web-gui/data/cs_server/CGI";
use Digest::SHA::PurePerl qw(sha256_hex);                    # replaces md5m, $hash = sha256_hex($data); 96 char
use IO::Socket::INET;

# common lib
require "$dpath/menues/_lib/windows/task-lib.pl";        #
require "$wpath/data/wwwroot/cgi-bin/admin-wlib.pl";

$par=$ARGV[0];
 if (!(defined($par))) {
     &log("job-other:  missing parameter");
     exit;
 }



 ############

 #par: action_job timestamp
 $par=~s/ .*//;

 # parameter: action_$job time
 if (!($par =~/\w+\_\d+$/)) {
     print "job-other 20: wrong par $par";
     exit;
 }
 @t=();
 @t=split(/\_/,$par);    # action job
 $action=$t[0];
 $action=~s/[^a-z]//g;

 $id=$t[1];
  $opt=$ARGV[1];
 #############################################


# run?
if ($action eq "")                     {  print "job-other 42: wrong action - must be not empty\n";      exit; }
if (!("run,cancel,delete"=~/$action/)) {  print "job-other 43: wrong action - must be run: $action \n";  exit; }

#cancel or delete - optional
#if ($action eq "cancel") { &my_cancel; $info="cancel job"; &my_log; exit; }
if ($action eq "delete") { &my_delete; $info="delete job"; exit; }

#debug
# print "job-scrub 38: run id=$id par $par\n";

if ($action eq "run") {

     $t=&task_jobproc;                  # optionally restart with unique _csperl_id run_id p123
     $t=&task_norestart($id);           # do not run twice, returns ok to continue 

     if ($t ne "ok") {
         print __LINE__." cannot (re)start job: $id $t\n";
         &my_log_id("execution cancelled, job $id is $t");                           # only last.log to preserver error as default
         &my_log_last("execution cancelled, job $id is $t");
         exit;

     } else {

         print "start next other $id\n";
         &my_log_id("next other started");
     }
}

# get par -> %current
&task_read_jobpar($id);

&get_cfg;      # get cfg and auths

$error=&my_run;
&my_log;
exit;


  ## delete job
 sub my_delete {
 ##############
 my ($r);
      if ($id ne "") {
        $r=`sudo rm -f /var/web-gui/_log/jobs/$id.*`;
        print "##### job-other 68: delete $id ######  $r\n";
      } else {
        print "job-scrub delete, no id !! ########### \n";
      }
 }

  ## run job (child process)
 sub my_run {
 ############

 #print "job-other 67\n";

    my $t;

    $t=$id."_name";
    my $name         = $current{$t};          #"=name=";

    $t=$id."_action";
    my $action       = $current{$t};          #"=action=";

    $t=$id."_condition";
    my $condition    = $current{$t};          #"=condition=";

    $t=$id."_err";
    my $err          = $current{$t};          #"=err=";

    $t=$id."_noerr";
    my $noerr        = $current{$t};          #"=noerr=";


    #run action
    my $r=`$action 2>&1`;
    print __LINE__." $action\nreturn:\n$r";
    $info="$action\: $r";

    if ($condition eq "never")  { return(); }
    if ($condition eq "always") { return($r); }

    #condition
    my ($e,$n);
    if ($r=~/$err/s)   { $e="1"; }           # error found
    if ($r=~/$noerr/s) { $n="1"; }           # noerror found

    if ($err eq "")    { $e=""; }
    if ($noerr eq "")  { $n=""; }

   #print "$info\nerr:$err\nnoerr:$noerr\ne=$e\nn=$n ";

    if ($n eq "1")     { return (); }        # is noerror
    if ($e eq "1")     { return ($r); }      # is error
    if ($noerr ne "")  { return ($r); }      # return value but noerr not found

    return();                                # noerror not found and error not found

 }



###########  ## log last run in jobfile /_log/jobs/id...job
sub my_log {
###########

  # print "job-repli 548 - call log id=$id action=$action\n";

  # line 1: lastrun = ok or err
  # line 2: time of last run
  # line 3+: info

  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}

  my (@v,$v,$n,$l,$f1,$f2,@data);

  $l=$error;
  if ($l eq "") { $l="ok"; } else { $l="error"; $info="$info $error"; }

  $l=~s/\n/ /gs;
  $info=~s/\n.*//s;                                        # first line


 #stage 1: log general jobs
 ###########################
  my $log="$wpath/_log/jobs/jobs.log";
  my $lock="$wpath/_log/jobs/jobs.lock";
  open (X,"<$lock");
  flock(X, LOCK_EX);
          open (F,"<$log");
              flock(F, LOCK_EX);
              @data=<F>;
          close (F);

        #unshift   $l=ok/error
        unshift(@data,"$l; other $ref $id; time: $current{'timestamp'}; info: $info\n");

        if (@data > 50) {
                   $t=@data-50;
                   splice(@data,50,$t);
        }

       $t=join("",@data);
       open (PF, ">$log");
          flock(PF, LOCK_EX);
          print PF "$t";
       close (PF);
 close (X);

 if ($info=~/^delete /) { exit; }


 #stage 2 update job.par  $current{'logtime'};
  $log="$wpath/_log/jobs/$id.log";

  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);                                         # update last


  # stage 3 id.log newest at top
  ###################
  &my_logid("$l","info: $info");

  # update .par
  &task_gettime;                                             # $current{'timestamp'}, $current{'logtime'}
  $t="$id"."_last";                                              # update last
  $current{$t}=$current{'logtime'};
  &task_update_par($id);

 exit;  # log always last action

}


##############  log to id.log
sub my_logid {
#############
my $err =$_[0];
my $data=$_[1];
$data=~s/ +/ /g;
my @data;
&task_gettime;

my $log="$wpath/_log/jobs/$id.log";
  open (F,"<$log");
        flock(F, LOCK_EX);
        @data=<F>;
  close (F);

  #unshift   $l=ok/error
  unshift(@data,"$err; time: $current{'timestamp'}; $data\n");

  if (@data > 50) {
             $t=@data-50;
             splice(@data,50,$t);                 # delete from 50+
  }

 $t=join("",@data);
 open (PF, ">$log");
    flock(PF, LOCK_EX);
    print PF "$t";
 close (PF);


}



##
1;